/**
 * La classe Application reprsente le programme lui-mme.
 * 
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Appli {

    /**
     * La fentre principale
     */
    
    JFrame frame;

    /**
     * Le controleur
     */
    
    Controleur controle;
    
    /**
     * La barre d'outils
     */
    
    JCommande boutons;
    
    /**
     * La surface de dessin elle-mme
     */
    
    JDessin dessin;

    public Appli()
    {
	frame = new JFrame("Mon Beau Dessin");
	Container container= frame.getContentPane();

	// La surface de dessin peut supporter 100 lments
	
	dessin= new JDessin(100);
	
	controle= new Controleur(dessin);

	boutons= new JCommande(controle);
	boutons.addOutilButtonToggle(new OutilButtonToggle("cercle", new CreateurCercle()));
	boutons.addOutilButtonToggle(new OutilButtonToggle("=>", new FlecheOutil()));
	
        container.setLayout(new BorderLayout());
	container.add(dessin, BorderLayout.CENTER);
	container.add(boutons, BorderLayout.WEST);
	
	
	// Nous interceptons et utilisons la fermeture de fentre
	
	frame.addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent e) {
		    System.exit(0);
		}
	    });
	
	// pack calcule la taille de la fentre en fonction de ce qu'elle contient.
	
	frame.pack();
	frame.setVisible(true);
    }

    public static void main(String args[])
    {
	Appli e= new Appli();
    }
}

