/**
 * Cercles sur la surface de dessin
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Cercle extends Forme {
    int x, y, r;

    /**
     * Cre un cercle.
     * @param x abscisse du centre
     * @param y ordonne du centre
     * @param r rayon
     */
    
    public Cercle(int x, int y, int r)
    {
	this.x=x;
	this.y=y;
	this.r=r;
    }
    

    /**
     * Fonction de dessin.
     * @param g la surface de dessin
     */
    
    public void dessiner(Graphics g)
    {
	// Dessine le cercle.
	g.drawOval(x-r, y-r, r+r, r+r);
    }
    
    public boolean contains(int x1, int y1)
    {
	return (x-x1)*(x-x1) + (y-y1)*(y-y1) <= r*r;
    }


    public void move(int dx, int dy)
    {
	this.x+= dx;
	this.y+= dy;
    }

}
