
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * Le controleur a pour tche de rediriger les vnements qu'il reoit vers l'outil courant.
 */

public class Controleur implements MouseListener, MouseMotionListener {
    private Outil outilCourant;

    JDessin dessin;

    public Controleur(JDessin d) {
	dessin= d;
	d.addMouseListener(this);
	d.addMouseMotionListener(this);
    }

    public void setOutil(Outil o) {
	o.reset();
	outilCourant= o;
    }
    
    public Outil getOutil() {
	return outilCourant;
    }

    public JDessin getDessin() {
	return dessin;
    }

    // Implmentation des fonctions Listener
    // MouseListener
    
    public void mousePressed(MouseEvent e) {
	Outil o= getOutil();
	if (o != null) {
	    o.setSurfaceDeTravail(getDessin());
	    o.mousePressed(e);
	}
    }

    public void mouseReleased(MouseEvent e) {
	Outil o= getOutil();
	if (o != null) {
	    o.setSurfaceDeTravail(getDessin());
	    o.mouseReleased(e);
	}
    }

    public void mouseEntered(MouseEvent e) {
	Outil o= getOutil();
	if (o != null) {
	    o.setSurfaceDeTravail(getDessin());
	    o.mouseEntered(e);
	}
    }

    public void mouseExited(MouseEvent e) {
	Outil o= getOutil();
	if (o != null) {
	    o.setSurfaceDeTravail(getDessin());
	    o.mouseExited(e);
	}
    }

    public void mouseClicked(MouseEvent e) {
	Outil o= getOutil();
	if (o != null) {
	    o.setSurfaceDeTravail(getDessin());
	    o.mouseClicked(e);
	}
    }

    // MouseMotionListener

    public void mouseMoved(MouseEvent e) {
	Outil o= getOutil();
	if (o != null) {
	    o.setSurfaceDeTravail(getDessin());
	    o.mouseMoved(e);
	}
    }
    
    public void mouseDragged(MouseEvent e) {
	Outil o= getOutil();
	if (o != null) {
	    o.setSurfaceDeTravail(getDessin());
	    o.mouseDragged(e);
	}
    }
}
