/**
 *  Un objet Dessin est une liste de formes  dessiner.  Cet objet
 *  n'est pas forcment li  une fentre. On pourrait donc l'employer
 *  seul.  
*/


public class Dessin {
  
    /**
     * Les formes qui composent le dessin.
     */
    Forme [] formes;

    /**
     * Le nombre maximum de formes sur un dessin.
     */

    int maxFormes;

    /**
     * Le constructeur.
     * @param max nombre maximum de formes sur le dessin.
     */
    
    public Dessin(int max) {
	maxFormes= max;
	formes= new Forme[maxFormes];
    }

    /**
     * ajoute une forme au dessin.
     * @param f la forme  ajouter
     * @return true si l'ajout a fonctionn.
     */

    public boolean ajouter(Forme f) {
	boolean res= false;
	for (int i= 0; i < maxFormes; i++)
	    {
		if (formes[i] == null)
		    {
			formes[i]= f;
			res= true;
			break;
		    }
	    }
	return res;
    }

    /**
     * enlve une forme du dessin (sans la dtruire).
     * @param f la forme  enlever.
     */
    
    public void liberer(Forme f) {
	for (int i= 0; i < maxFormes; i++)
	    {
		if (formes[i] == f)
		    {
			formes[i]= null;
			break;
		    }
	    }
    }

    // Parcours des formes :
    
    /**
     * @return l'indice de la premiere forme, ou l'indice de fin s'il n'y en a pas.
     */
    public int getStart()
    {
	int i= 0;
	while(i < maxFormes && formes[i] == null)
	    i++;
	return i;
    }

    /**
     * @return l'indice de fin de parcours.
     */
    
    public int getEnd()
    {
	return maxFormes;
    }

    /**
     * @param i indice de la forme courante
     * @return l'indice de la forme suivante, ou l'indice de fin s'il n'y en a pas.
     */

    public int getNext(int i)
    {
	i++;
	while(i < maxFormes && formes[i] == null)
	    i++;
	return i;
    }
    
    /**
     * @param i l'indice de la forme
     * @return la forme  l'indice i
     */

    public Forme getForme(int i)
    {
	return formes[i];
    }
    
    /**
     * @return le premier lment trouv  la position x,y
     */
    
    public Forme choose(int x, int y)
    {
	Forme res= null;
	for (int i= getStart(); i != getEnd(); i= getNext(i))
	    {
		if (formes[i].contains(x,y))
		    res= formes[i];
	    }
	return res;
    }
}

