import java.awt.event.*;

/**
 * La flche est l'outil de dplacement et d'dition "par excellence".
 */

public class FlecheOutil extends Outil {
    
    /**
     * variables utilises pour suivre le dplacement du curseur.
     */
    
    private int lastx, lasty;
    
    /** 
     * La forme  dplacer.
     */
    
    Forme aDeplacer;

    public void reset() 
    {
	aDeplacer= null;
    }

    // Implmentation des fonctions Listener
    // MouseListener
    
    public void mousePressed(MouseEvent e) {
	lastx= e.getX();
	lasty= e.getY();
	aDeplacer= getSurfaceDeTravail().choose(lastx, lasty);
    }

    public void mouseReleased(MouseEvent e) {
	if (aDeplacer != null)
	    {
		int x,y;
		x= e.getX();
		y= e.getY();
		aDeplacer.move(x-lastx,y-lasty);
		lastx=x;
		lasty=y;
		getSurfaceDeTravail().repaint();
		aDeplacer= null;
	    }
    }

    public void mouseEntered(MouseEvent e) {
	// RIEN !
    }

    public void mouseExited(MouseEvent e) {
	// RIEN !
    }

    public void mouseClicked(MouseEvent e) {
	// RIEN
    }

    // MouseMotionListener

    public void mouseMoved(MouseEvent e) {
	// RIEN
    }
    
    public void mouseDragged(MouseEvent e) {
	    if (aDeplacer != null) {
		int x,y;
		x= e.getX();
		y= e.getY();
		aDeplacer.move(x-lastx,y-lasty);
		lastx=x;
		lasty=y;
		getSurfaceDeTravail().repaint();
	    }
    }
}
