
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * La classe abstraite forme correspond  toutes les figures qui
 * peuvent tre dessinnes sur un JDessin.
 */

public abstract class Forme {

    /**
     * Constructeur par dfaut de la forme
     */
    
    public Forme() {
    }

    /**
     * Fonction de dessin.
     * Le programmeur doit la redfinir pour des formes particulires.
     * @param g surface de dessin
     */
    
    abstract public void dessiner(Graphics g);

    /**
     * renvoie vrai si le point x et y est contenu dans la forme.
     * Le programmeur doit redfinir cette fonction pour des formes particulires.
     * @param x abscisse du point  tester
     * @param y ordonne du point  tester
     * @return true si le point est dans la forme, false sinon.
     */
    
    public abstract boolean contains(int x, int y);

    /**
     * deplace un objet
     * @param dx coordonnee x du vecteur deplacement
     * @param dy coordonnee y du vecteur deplacement
     */

    public abstract void move(int dx, int dy);
    
    
}
