import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/** 
 * Un objet Commande est une barre d'outils qui contrle un JDessin.
 * Dans la version 2001, le systme est plus paramtrable.
 */

public class JCommande extends JToolBar implements ActionListener {

    /** 
     * ButtonGroup pour grer l'exclusion mutuelle des boutons
     */

    private ButtonGroup lesBoutons;

    private Controleur controle;
    
    public JCommande(Controleur c) {
	// La barre d'outils est verticale :
	super(VERTICAL);
	lesBoutons= new ButtonGroup();
	controle= c;
    }

    public Controleur getControle() {
	return controle;
    }
    /**
     * ajoute un outil  cette barre
     */
    
    public void addOutilButtonToggle(OutilButtonToggle o) {
	// Ajouter le bouton  l'objet graphique
	add(o);
	// Ajouter le bouton au groupe de boutons
	lesBoutons.add(o);
	// s'enregistrer comme traitant le bouton
	o.addActionListener(this);
    }
    
    /**
     * ATTENTION !!!!
     * Cette actionPerformed ne fonctionne que sur des outilSelectors
     */
    
    public void actionPerformed(ActionEvent e) {
	OutilButtonToggle os= (OutilButtonToggle)e.getSource();
	getControle().setOutil(os.getOutil());
    }
}




