
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * Un JDessin est une surface de dessin active.
 */

public class JDessin extends JPanel {

    // Dimensions minimales du JDessin
    Dimension dimensions;

    // Le dessin proprement dit
    Dessin dessin;

    /**
     * Constructeur de JDessin
     * @param max nombre maximum d'lments dans un dessin
     */
    
    public JDessin(int max) {
	// On demande des dimensions minimales de 200x200
	dimensions= new Dimension(200,200);
	// Cration du dessin
	dessin= new Dessin(max);
	setBackground(Color.white);

    }

    /**
     * Ajout d'une forme sur le JDessin
     * @param f forme  ajouter
     */
    
    public void ajouter(Forme f) {
	dessin.ajouter(f);
	repaint();
    }

    /**
     * Suppression d'une forme sur le JDessin.
     * La forme n'est pas dtruite !
     * @param f forme  enlever
     */
    
    public void liberer(Forme f) {
	dessin.liberer(f);
	repaint();
    }

    /**
     * Fonction de dessin du  JDessin.
     * C'est de cette faon que vous pouvez redfinir vos propres types de fentres graphiques.
     * Notez qu' chaque modification, la fentre est a priori entirement redessin
     * @param g contexte graphique
     */
    
    public void paintComponent(Graphics g) {
	// Dessiner le fond. Obligatoire pour un bon fonctionnement !
	super.paintComponent(g); 
	
	// Pour chaque forme du dessin
	for (int i= dessin.getStart(); i != dessin.getEnd(); i= dessin.getNext(i))
	    {
		// La dessiner
		dessin.getForme(i).dessiner(g); 
	    }
    }

    public Forme choose(int x, int y)
    {
	return dessin.choose(x,y);
    }

    // Vous pouvez ignorer les deux mthodes qui suivent
    
    public Dimension getMinimumSize() {
        return dimensions;
    }

    public Dimension getPreferredSize() {
        return dimensions;
    }
    
}
