import java.awt.*;
import java.awt.event.*;


/**
 * Un outil est un objet qui permet de manipuler le dessin.
 */

public abstract class Outil implements MouseListener, MouseMotionListener {
    
    private JDessin surfaceTravail;

    /**
     * Createur d'outil.
     */

    public Outil()
    {
	setSurfaceDeTravail(null);
    }

    /**
     * Fixe la surface de travail de cet outil
     */
    
    public void setSurfaceDeTravail(JDessin d)
    {
	surfaceTravail= d;
    }

    /**
     * Rcupre la surface de travail de cet outil
     */
    
    public JDessin getSurfaceDeTravail()
    {
	return surfaceTravail;
    }

    /**
     * Remise " 0" d'ventuelles variables dcrivant l'tat d'une manipulation
     */

    abstract public void reset();

    // Implmentation des fonctions Listener
    // MouseListener

    public void mousePressed(MouseEvent e) {
	// RIEN
    }

    public void mouseReleased(MouseEvent e) {
	// RIEN
    }

    public void mouseEntered(MouseEvent e) {
	// RIEN !
    }

    public void mouseExited(MouseEvent e) {
	// RIEN !
    }

    public void mouseClicked(MouseEvent e) {
	// RIEN
    }

    // MouseMotionListener

    public void mouseMoved(MouseEvent e) {
	// RIEN
    }
    
    public void mouseDragged(MouseEvent e) {
	// RIEN
    }
}
